%define oname pygobject

%define api 2.0
%define major 0
%define libname %mklibname pyglib-gi %api %major

%global __provides_exclude_from ^(%{py_platsitedir}|%{python3_sitearch})/(pygtkcompat|gi/pygtkcompat.py|gi/_gobject/__init__.py|gi/module.py|gi/__init__.py|gi/overrides/GIMarshallingTests.py)
%global __requires_exclude_from ^(%{py_platsitedir}|%{python3_sitearch})/(pygtkcompat|gi/pygtkcompat.py|gi/_gobject/__init__.py|gi/module.py|gi/__init__.py|gi/overrides/GIMarshallingTests.py)

%global __requires_exclude typelib\\(%%namespaces

%define url_ver %(echo %{version} | cut -d "." -f -2)

%define with_python3 1

Summary:	Python bindings for GObject Introspection
Name:		python-gobject3
Version:	3.24.1
Release:	%mkrel 1
Source0:	https://download.gnome.org/sources/%{oname}/%{url_ver}/%{oname}-%{version}.tar.xz
Patch0:		pygobject-3.19.2-link.diff
License:	LGPLv2+ and MIT
Group:		Development/Python
Url:		http://www.gnome.org
BuildRequires:	pkgconfig(python) >= 2.7
BuildRequires:	pkgconfig(glib-2.0) >= 2.38.0
BuildRequires:	pkgconfig(gobject-introspection-1.0) >= 1.38.0
BuildRequires:	pkgconfig(libffi) >= 3.0
BuildRequires:	pkgconfig(pycairo) >= 1.2.0
BuildRequires:	gnome-common
BuildRequires:	gtk-doc
BuildRequires:	automake
%if %{with_python3}
BuildRequires:  pkgconfig(python3) >= 3.1
BuildRequires:  pkgconfig(py3cairo) >= 1.10.0
%endif

%description
The %{name} package provides a convenient wrapper for the GObject library
for use in Python programs.

%package -n python-gi
Summary:	Python bindings for GObject Introspection
Group:		Development/Python
Provides:	python-gobject-introspection = %{version}-%{release}
Provides:	%{name} = %{version}-%{release}
Conflicts:	python-gobject < 2.28.6-4

%description -n python-gi
The %{name} package provides a convenient wrapper for the GObject library
for use in Python programs.

This package contains the Python GObject Introspection bindings.

%package -n python-gi-cairo
Summary:	Python-gi bindings for Cairo
Group:		Development/Python
Requires:	python-gi = %{version}-%{release}
Requires:	python-cairo >= 1.2.0
Obsoletes:	python-gobject-cairo < 2.28.6-4
Provides:	python-gobject-cairo = %{version}-%{release}

%description -n python-gi-cairo
The %{name} package provides a convenient wrapper for the GObject library
for use in Python programs.

This package contains the Python-gi Cairo bindings.

%package -n %{libname}
Group:		System/Libraries
Summary:	Python GObject Introspection bindings shared library

%description -n %{libname}
This archive contains bindings for the GObject, to be used in Python
It is a fairly complete set of bindings, it's already rather useful, 
and is usable to write moderately complex programs.

%package devel
Group:		Development/C
Summary:	Python-gobject development files
Requires:	%{name} = %{version}-%{release}
# ovitters: pkgconfig(gobject-introspection-1.0) includes script to determine typelib() auto buildrequires
Requires:	pkgconfig(gobject-introspection-1.0)

%description devel
This contains the python-gobject development files, including C
header, pkg-config file.

%if %{with_python3}
%package -n python3-gobject3
Summary:	Python 3 bindings for GObject Introspection
Group:		Development/Python
Requires:	python3-cairo >= 1.10.0-15
Requires:	gobject-introspection

%description -n python3-gobject3
This package provides a convenient wrapper for the GObject library and other
libraries that are compatible with GObject Introspection, for use with Python 3
programs.

%package -n python3-gobject3-devel
Group:		Development/C
Summary:	Python3-gobject development files
Requires:	python3-gobject3 = %{version}-%{release}
# ovitters: pkgconfig(gobject-introspection-1.0) includes script to determine typelib() auto buildrequires
Requires:	pkgconfig(gobject-introspection-1.0)
Conflicts:	%{name}-devel < 3.10.0-2

%description -n python3-gobject3-devel
This contains the python-gobject development files, including C
header, pkg-config file.
%endif

%prep
%setup -q -c -T

# Python 2
tar xf %{SOURCE0}
pushd pygobject-%{version}
%patch0 -p0
popd
mv pygobject-%{version} python2

# Python 3
%if %{with_python3}
cp -ar python2 python3
%endif

# fix shebangs
find python2 -name '*.py' | xargs sed -i '1s|^#!python|#!%{__python}|'
%if %{with_python3}
find python3 -name '*.py' | xargs sed -i '1s|^#!python|#!%{__python3}|'
%endif

%build
# Python 2
pushd python2
	export PYTHON=%{__python}
	autoreconf -vfi
	%configure2_5x
	%make
popd

%if %{with_python3}
# Python 3
pushd python3
	export PYTHON=%{__python3}
	autoreconf -vfi
	%configure2_5x
	%make
popd
%endif

%install
# Python 2
pushd python2
	export PYTHON=%{__python}
	%makeinstall_std
popd

%if %{with_python3}
# Python 3
pushd python3
	export PYTHON=%{__python3}
	%makeinstall_std
popd
%endif

find %buildroot \( -name '*.la' -o -name '*.a' \) -delete

# dsextra stuff is for windows installs so remove it
rm -fr %{buildroot}%{python_sitearch}/gtk-2.0

# docs are out of date and are being reworked upstream
# so remove them
rm -rf %{buildroot}%{_datadir}/gtk-doc
rm -rf %{buildroot}%{_datadir}/pygobject

%files -n python-gi
%doc python2/README python2/NEWS python2/AUTHORS
%py_platsitedir/gi
%py_platsitedir/pygtkcompat
%py_platsitedir/*.egg-info
# Live in cairo subpackage
%exclude %py_platsitedir/gi/_gi_cairo.so

%files -n python-gi-cairo
%py_platsitedir/gi/_gi_cairo.so

%files devel
%{_includedir}/*
%{_libdir}/pkgconfig/*.pc

%if %{with_python3}
%files -n python3-gobject3
%python3_sitearch/gi
%python3_sitearch/pygtkcompat
%python3_sitearch/*.egg-info
%endif


%changelog
* Mon Apr 10 2017 ovitters <ovitters> 3.24.1-1.mga6
+ Revision: 1096250
- new version 3.24.1

* Tue Mar 21 2017 ovitters <ovitters> 3.24.0-1.mga6
+ Revision: 1094026
- new version 3.24.0

* Sat Sep 24 2016 ovitters <ovitters> 3.22.0-1.mga6
+ Revision: 1055753
- new version 3.22.0

* Mon May 23 2016 joequant <joequant> 3.20.1-4.mga6
+ Revision: 1017899
- remove GIMarshallingTests requires

* Mon May 23 2016 joequant <joequant> 3.20.1-3.mga6
+ Revision: 1017879
- bump to build on arm

* Thu Apr 28 2016 tv <tv> 3.20.1-2.mga6
+ Revision: 1007106
- use new python macros

* Mon Apr 25 2016 ovitters <ovitters> 3.20.1-1.mga6
+ Revision: 1006030
- new version 3.20.1

  + tv <tv>
    - do not package huge ChangeLog

* Tue Mar 22 2016 ovitters <ovitters> 3.20.0-1.mga6
+ Revision: 993890
- new version 3.20.0

* Wed Mar 16 2016 ovitters <ovitters> 3.19.92-1.mga6
+ Revision: 991837
- new version 3.19.92

* Wed Mar 02 2016 ovitters <ovitters> 3.19.91-1.mga6
+ Revision: 982670
- new version 3.19.91

* Sun Feb 21 2016 ovitters <ovitters> 3.19.90-1.mga6
+ Revision: 975036
- new version 3.19.90

* Sat Feb 13 2016 luigiwalser <luigiwalser> 3.19.2-2.mga6
+ Revision: 959436
- link with python lib to fix python3 build

* Mon Nov 23 2015 ovitters <ovitters> 3.19.2-1.mga6
+ Revision: 904997
- new version 3.19.2

* Sat Oct 24 2015 ovitters <ovitters> 3.18.2-1.mga6
+ Revision: 895008
- new version 3.18.2

* Sat Oct 24 2015 ovitters <ovitters> 3.18.1-1.mga6
+ Revision: 894980
- new version 3.18.1

* Wed Oct 07 2015 tv <tv> 3.18.0-3.mga6
+ Revision: 886696
- rebuild for python 3.5

* Fri Oct 02 2015 tv <tv> 3.18.0-2.mga6
+ Revision: 885743
- require fixed python3-cairo (mga#16845)

* Fri Sep 25 2015 tv <tv> 3.18.0-1.mga6
+ Revision: 883484
- new release

* Thu Aug 20 2015 ovitters <ovitters> 3.17.90-1.mga6
+ Revision: 866617
- new version 3.17.90

* Thu Jul 09 2015 ovitters <ovitters> 3.17.1-1.mga6
+ Revision: 853147
- new version 3.17.1

* Wed Oct 15 2014 umeabot <umeabot> 3.14.0-2.mga5
+ Revision: 742916
- Second Mageia 5 Mass Rebuild

* Wed Oct 01 2014 wally <wally> 3.14.0-1.mga5
+ Revision: 733830
- new version 3.14.0

* Sat Sep 27 2014 tv <tv> 3.13.92-3.mga5
+ Revision: 728610
- rebuild for missing pythoneggs deps

* Tue Sep 16 2014 umeabot <umeabot> 3.13.92-2.mga5
+ Revision: 688058
- Mageia 5 Mass Rebuild

  + tv <tv>
    - simplify
    - auto convert _exclude_files_from_autoreq
    - use %%global for req/prov exclude

* Tue Sep 16 2014 ovitters <ovitters> 3.13.92-1.mga5
+ Revision: 676967
- new version 3.13.92

  + tv <tv>
    - autoconvert to new prov/req excludes

* Sun Sep 14 2014 ovitters <ovitters> 3.13.4-2.mga5
+ Revision: 675393
- remove unneeded patch which didn't apply
- devel subpackages should ensure gobject-introspection is installed for auto typelib buildrequires

* Tue Jun 24 2014 ovitters <ovitters> 3.13.3-1.mga5
+ Revision: 639213
- new version 3.13.3

* Sun Jun 01 2014 wally <wally> 3.12.2-1.mga5
+ Revision: 630305
- add patch to fix linking

  + pterjan <pterjan>
    - 3.12.2
    - Rebuild for new Python

* Tue Feb 18 2014 fwang <fwang> 3.11.90-2.mga5
+ Revision: 594175
- update filter

* Tue Feb 18 2014 fwang <fwang> 3.11.90-1.mga5
+ Revision: 594158
- update file list

  + ovitters <ovitters>
    - new version 3.11.90

* Mon Nov 11 2013 ovitters <ovitters> 3.10.2-1.mga4
+ Revision: 550507
- new version 3.10.2

* Tue Oct 22 2013 umeabot <umeabot> 3.10.1-3.mga4
+ Revision: 543595
- Mageia 4 Mass Rebuild

* Tue Oct 15 2013 pterjan <pterjan> 3.10.1-2.mga4
+ Revision: 498698
- Rebuild to add different pythonegg provides for python 2 and 3

* Mon Oct 14 2013 ovitters <ovitters> 3.10.1-1.mga4
+ Revision: 496953
- new version 3.10.1

* Wed Sep 25 2013 fwang <fwang> 3.10.0-2.mga4
+ Revision: 485887
- split our python3 libs

* Mon Sep 23 2013 ovitters <ovitters> 3.10.0-1.mga4
+ Revision: 484127
- new version 3.10.0

* Tue Sep 17 2013 fwang <fwang> 3.9.92-7.mga4
+ Revision: 480680
+ rebuild (emptylog)

* Tue Sep 17 2013 fwang <fwang> 3.9.92-6.mga4
+ Revision: 480664
- fix typo on splitter

* Tue Sep 17 2013 fwang <fwang> 3.9.92-5.mga4
+ Revision: 480656
- filter correct files

* Tue Sep 17 2013 fwang <fwang> 3.9.92-4.mga4
+ Revision: 480647
- only filter pygtkcompat

* Tue Sep 17 2013 fwang <fwang> 3.9.92-3.mga4
+ Revision: 480638
- mask more files

* Tue Sep 17 2013 fwang <fwang> 3.9.92-2.mga4
+ Revision: 480634
- update exclude file list

* Tue Sep 17 2013 ovitters <ovitters> 3.9.92-1.mga4
+ Revision: 480545
- new version 3.9.92

* Sun Sep 01 2013 tmb <tmb> 3.9.90-1.mga4
+ Revision: 473799
- update to 3.9.90

* Thu Aug 08 2013 wally <wally> 3.8.2-4.mga4
+ Revision: 464637
- rebuild with new rpm-mageia-setup

* Sat May 25 2013 ovitters <ovitters> 3.8.2-3.mga4
+ Revision: 427550
- really fix requires

* Sat May 25 2013 ovitters <ovitters> 3.8.2-2.mga4
+ Revision: 427540
- fix work autorequire

* Sat May 25 2013 ovitters <ovitters> 3.8.2-1.mga4
+ Revision: 427426
- update file list
- new version 3.8.2

* Sun Jan 13 2013 umeabot <umeabot> 3.4.2-2.mga3
+ Revision: 378935
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Nov 13 2012 fwang <fwang> 3.4.2-1.mga3
+ Revision: 317339
- update file list
- new version 3.4.2

  + ovitters <ovitters>
    - new version 3.4.1.1

* Mon Oct 15 2012 fwang <fwang> 3.4.1-1.mga3
+ Revision: 306020
- update file list
- update file list

  + ovitters <ovitters>
    - new version 3.4.1

* Sat Sep 29 2012 fwang <fwang> 3.4.0-2.mga3
+ Revision: 300330
- rebuild for new py3.3

* Mon Sep 24 2012 fwang <fwang> 3.4.0-1.mga3
+ Revision: 297069
- new version 3.4.0

* Tue Sep 18 2012 fwang <fwang> 3.3.92-1.mga3
+ Revision: 295730
- new version 3.3.92

* Mon Aug 06 2012 fwang <fwang> 3.3.5-1.mga3
+ Revision: 279380
- new version 3.3.5

* Fri Jul 13 2012 fwang <fwang> 3.3.3.1-5.mga3
+ Revision: 270611
- update file list to fix file conflicts

* Fri Jul 13 2012 fwang <fwang> 3.3.3.1-4.mga3
+ Revision: 270525
- do not requires python-gi

* Fri Jul 13 2012 fwang <fwang> 3.3.3.1-3.mga3
+ Revision: 270517
- update file list
- update file list

* Fri Jul 13 2012 kamil <kamil> 3.3.3.1-2.mga3
+ Revision: 270476
- add python3 subpackage

* Tue Jul 03 2012 kamil <kamil> 3.3.3.1-1.mga3
+ Revision: 267105
- new version 3.3.3.1
- remove P0 (not used anymore)
- new P0 pygobject-3.3.3.1-fix-segfault-with-class-interface-mismatch.patch from Fedora

* Mon May 14 2012 ovitters <ovitters> 3.2.2-1.mga3
+ Revision: 235674
- new version 3.2.2
- new version 3.2.1

* Sat Apr 07 2012 fwang <fwang> 3.2.0-3.mga2
+ Revision: 229564
- fix typo on filter

* Sat Apr 07 2012 fwang <fwang> 3.2.0-2.mga2
+ Revision: 229556
- do not push autoreq from pygtkcompat module

* Mon Mar 26 2012 ovitters <ovitters> 3.2.0-1.mga2
+ Revision: 226573
- new version 3.2.0

* Fri Mar 23 2012 anssi <anssi> 3.1.93-2.mga2
+ Revision: 225856
- drop patch which adapted to API change made in upstream GTK+ bug
  #657385, it has now been reverted in GTK+ 3.3.20

* Thu Mar 22 2012 ovitters <ovitters> 3.1.93-1.mga2
+ Revision: 225662
- new version 3.1.93

* Mon Mar 19 2012 ovitters <ovitters> 3.1.92-1.mga2
+ Revision: 224400
- new version 3.1.92

* Wed Mar 07 2012 anssi <anssi> 3.1.1-2.mga2
+ Revision: 221179
- adapt for an API change made in gnome bug #657385 (this change might
  get reverted later, though; adapt-for-gnome657385.patch)

* Tue Feb 21 2012 fwang <fwang> 3.1.1-1.mga2
+ Revision: 211318
- new version 3.1.1

* Mon Feb 06 2012 fwang <fwang> 3.1.0-1.mga2
+ Revision: 205459
- new version 3.1.0

* Tue Dec 13 2011 fwang <fwang> 3.0.3-1.mga2
+ Revision: 181240
- new version 3.0.3

* Tue Oct 25 2011 fwang <fwang> 3.0.2-1.mga2
+ Revision: 157981
- new version 3.0.2

* Sat Oct 01 2011 wally <wally> 3.0.1-1.mga2
+ Revision: 150638
- new version 3.0.1

* Mon Sep 19 2011 wally <wally> 3.0.0-1.mga2
+ Revision: 145640
- new version 3.0.0
- clean .spec a bit

* Fri Sep 16 2011 fwang <fwang> 2.90.4-1.mga2
+ Revision: 144176
- fix linkage
- new version 2.90.4

* Thu Sep 01 2011 fwang <fwang> 2.90.3-1.mga2
+ Revision: 137427
- new version  2.90.3
- disable wrong script for checking req
- imported package python-gobject3

  + wally <wally>
    - fix typo in python-gi-cairo provides/requires

